(define (memoize size proc)
  (let ((table (make-hash-table size))
        (unique (list #f)))
    (define (memoized . args)
      (let* ((entry (hash-create-handle! table args unique)))
        (if (eq? (cdr entry) unique)
          (set-cdr! entry (apply proc args)))
        (cdr entry)))
    (set-procedure-property! memoized 'name (procedure-name proc))
    memoized))

(define (uniquifier size)
  (let ((table (make-hash-table size)))
    (define (uniquify obj)
      (car (hash-create-handle! table obj #f)))
    uniquify))
